#![ allow( dead_code, unused, non_snake_case, non_camel_case_types, unused_assignments ) ]
use std::fmt;
use rand::{thread_rng, Rng};
use btypes::butils;
use btypes::bobject;
use btypes::bboolean::{IntoBool, BBooleanT};
use btypes::binteger::BInteger;
use btypes::bboolean::BBoolean;
mod CAN_BUS_tlc;



#[derive(Clone, Default, Debug, Hash, PartialEq, Eq)]
pub struct CAN_BUS_tlc_exec {
    counter: BInteger,
    _CAN_BUS_tlc: CAN_BUS_tlc::CAN_BUS_tlc,
}

impl fmt::Display for CAN_BUS_tlc_exec {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        let mut result = "CAN_BUS_tlc_exec: (".to_owned();
        result += &format!("_get_counter: {}, ", self._get_counter());
        result = result + ")";
        return write!(f, "{}", result);
    }
}

impl CAN_BUS_tlc_exec {

    pub fn new() -> CAN_BUS_tlc_exec {
        //values: ''
        let mut m: CAN_BUS_tlc_exec = Default::default();
        m.init();
        return m;
    }
    fn init(&mut self) {
        self.counter = BInteger::new(0);
        self._CAN_BUS_tlc = CAN_BUS_tlc::CAN_BUS_tlc::new();
    }

    pub fn _get_counter(&self) -> BInteger {
        return self.counter.clone();
    }

    pub fn simulate(&mut self) -> () {
        self._CAN_BUS_tlc.Update(BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2Calculate();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(1));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(1));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(1));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(1));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1).negative());
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(3));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(3));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(0));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T2Reset();
        self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3Poll();
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(5));
        self._CAN_BUS_tlc.T2Evaluate();
        self._CAN_BUS_tlc.T3Evaluate();
        self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T2Complete();
        self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
        self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
        self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
        self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
        self._CAN_BUS_tlc.T3ReEnableWait();
        self._CAN_BUS_tlc.Update(BInteger::new(3));
        self._CAN_BUS_tlc.T1Evaluate();
        self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
        self._CAN_BUS_tlc.T3Initiate();
        self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
        self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
        self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
        self._CAN_BUS_tlc.T3Wait();
        self._CAN_BUS_tlc.Update(BInteger::new(4));
        while (self.counter.less(&BInteger::new(300000))).booleanValue() {
            self._CAN_BUS_tlc.T3Evaluate();
            self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
            self._CAN_BUS_tlc.T3Poll();
            self._CAN_BUS_tlc.T3Wait();
            self._CAN_BUS_tlc.Update(BInteger::new(4));
            self._CAN_BUS_tlc.T3Evaluate();
            self._CAN_BUS_tlc.T2Evaluate();
            self._CAN_BUS_tlc.T3Read(BInteger::new(4),BInteger::new(0));
            self._CAN_BUS_tlc.T2ReadBus(BInteger::new(4),BInteger::new(0));
            self._CAN_BUS_tlc.T3Poll();
            self._CAN_BUS_tlc.T2Reset();
            self._CAN_BUS_tlc.T3Wait();
            self._CAN_BUS_tlc.T1Evaluate();
            self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
            self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
            self._CAN_BUS_tlc.T2WriteBus(BInteger::new(5),BInteger::new(0));
            self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
            self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
            self._CAN_BUS_tlc.Update(BInteger::new(5));
            self._CAN_BUS_tlc.T3Evaluate();
            self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
            self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
            self._CAN_BUS_tlc.T3ReEnableWait();
            self._CAN_BUS_tlc.Update(BInteger::new(5));
            self._CAN_BUS_tlc.T1Evaluate();
            self._CAN_BUS_tlc.T1Calculate(BInteger::new(2));
            self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(2));
            self._CAN_BUS_tlc.T3Initiate();
            self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
            self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
            self._CAN_BUS_tlc.T3Wait();
            self._CAN_BUS_tlc.Update(BInteger::new(5));
            self._CAN_BUS_tlc.T2Evaluate();
            self._CAN_BUS_tlc.T3Evaluate();
            self._CAN_BUS_tlc.T2ReadBus(BInteger::new(5),BInteger::new(0));
            self._CAN_BUS_tlc.T2Complete();
            self._CAN_BUS_tlc.T2ReleaseBus(BInteger::new(5));
            self._CAN_BUS_tlc.T2Wait(BInteger::new(3));
            self._CAN_BUS_tlc.T3Read(BInteger::new(5),BInteger::new(0));
            self._CAN_BUS_tlc.T3ReleaseBus(BInteger::new(4));
            self._CAN_BUS_tlc.T3ReEnableWait();
            self._CAN_BUS_tlc.Update(BInteger::new(3));
            self._CAN_BUS_tlc.T1Evaluate();
            self._CAN_BUS_tlc.T1Calculate(BInteger::new(1));
            self._CAN_BUS_tlc.T3Initiate();
            self._CAN_BUS_tlc.T1SendResult(BInteger::new(3),BInteger::new(1));
            self._CAN_BUS_tlc.T3writebus(BInteger::new(4),BInteger::new(0));
            self._CAN_BUS_tlc.T1Wait(BInteger::new(2));
            self._CAN_BUS_tlc.T3Wait();
            self._CAN_BUS_tlc.Update(BInteger::new(4));
            self.counter = self.counter.plus(&BInteger::new(1));
        }
    }
}

fn main() {
    let mut can_exec = CAN_BUS_tlc_exec::new();
    can_exec.simulate();
}